# encoding: UTF-8

module AbsTime
	module ApplicationHelperPatch
		def self.included(base)
			base.send(:include, InstanceMethods)

			base.class_eval do
				unloadable

				alias_method_chain :render_page_hierarchy, :abs_time
				alias_method_chain :authoring, :abs_time
			end
		end

		module InstanceMethods
			def render_page_hierarchy_with_abs_time(pages, node=nil, options={})
				content = '' 
				if pages[node]
					content << "<ul class=\"pages-hierarchy\">\n"
					pages[node].each do |page|
						content << "<li>"
						content << link_to(h(page.pretty_title), {:controller => 'wiki', :action => 'show', :project_id => page.project, :id => page.title, :version => nil},
								:title => (options[:timestamp] && page.updated_on ? l(:label_updated_time, distance_of_time_in_words(Time.now, page.updated_on), :time => page.updated_on) : nil))
						content << "\n" + render_page_hierarchy(pages, page.id, options) if pages[page.id]
						content << "</li>\n"
					end  
					content << "</ul>\n"
				end  
				content.html_safe
			end
			def authoring_with_abs_time(created, author, options={})
				l(options[:label] || :label_added_time_by, :author => link_to_user(author), :age => time_tag(created), :time => created).html_safe
			end
		end
	end
end

